//---------------------------------------------------------------------------

#include <vcl.h>
#pragma hdrstop

#include "Unit1.h"
#include "algorithm.h"
#include "math.h"
#include "math.hpp"

#define SHOW_IMAGE_LENGTH 300
#define SRC_PANEL_LENGTH SHOW_IMAGE_LENGTH+2*2
#define DST_PANEL_LENGTH 425+2*2
#define PI 3.14159

//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma link "CGAUGES"
#pragma link "CSPIN"
#pragma resource "*.dfm"
TForm1 *Form1;
//---------------------------------------------------------------------------
__fastcall TForm1::TForm1(TComponent* Owner)
   : TForm(Owner)
{
   Panel1->Width=SRC_PANEL_LENGTH;
   Panel1->Height=SRC_PANEL_LENGTH;
   Panel1->DoubleBuffered=true;

   Panel2->Width=DST_PANEL_LENGTH;
   Panel2->Height=DST_PANEL_LENGTH;
   Panel2->DoubleBuffered=true;

   iOldAngle=0;
   bmpSrc=NULL;
   bmpDst=NULL;

   Button1->Enabled=false;
   Button4->Enabled=false;
}
__fastcall TForm1::~TForm1()
{
   if(bmpSrc) delete bmpSrc;
   if(bmpDst) delete bmpDst;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button1Click(TObject *Sender)
{
   int iAngle=0;
   try
   {
      iAngle=StrToInt(CSpinEdit1->Text);
      if(iAngle<0)
      {
         iAngle+=((-iAngle/360+1)*360);
      }
      iAngle%=360;
   }
   catch(Exception &e)
   {
      CSpinEdit1->Text="0";
      iAngle=0;
   }
   if(iOldAngle==iAngle) return;
   iOldAngle=iAngle;

   if(bmpDst)
   {
      delete bmpDst;
      bmpDst=NULL;
   }

   bmpDst=new Graphics::TBitmap;
   RotateBitmap(bmpSrc, bmpDst, iAngle);

   Image2->Width=(int)((double)SHOW_IMAGE_LENGTH*(double)bmpDst->Width/(double)bmpSrc->Width);
   Image2->Height=(int)((double)SHOW_IMAGE_LENGTH*(double)bmpDst->Height/(double)bmpSrc->Width);
   Image2->Left=(Panel2->Width-Image2->Width)/2;
   Image2->Top=(Panel2->Height-Image2->Height)/2;
   Image2->Stretch=true;
   Image2->Picture->Bitmap=NULL;
   Image2->Picture->Bitmap->Assign(bmpDst);

   Button4->Enabled=true;
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button2Click(TObject *Sender)
{
   Close();
}
//---------------------------------------------------------------------------
void __fastcall TForm1::Button3Click(TObject *Sender)
{
   OpenPictureDialog1->InitialDir=ExtractFilePath(Application->ExeName);
   if(OpenPictureDialog1->Execute())
   {
      if(FileExists(OpenPictureDialog1->FileName))
      {
         if(bmpSrc)
         {
            delete bmpSrc;
            bmpSrc=NULL;
         }
         bmpSrc=new Graphics::TBitmap;
         bmpSrc->LoadFromFile(OpenPictureDialog1->FileName);
         if(bmpSrc->Width>=bmpSrc->Height)
         {
            Image1->Width=SHOW_IMAGE_LENGTH;
            Image1->Height=(int)((double)SHOW_IMAGE_LENGTH*(double)bmpSrc->Height/(double)bmpSrc->Width);
         }
         else
         {
            Image1->Height=SHOW_IMAGE_LENGTH;
            Image1->Width=(int)((double)SHOW_IMAGE_LENGTH*(double)bmpSrc->Width/(double)bmpSrc->Height);
         }
         Image1->Left=(Panel1->Width-Image1->Width)/2;
         Image1->Top=(Panel1->Height-Image1->Height)/2;
         Image1->Stretch=true;
         Image1->Picture->Bitmap->Assign(bmpSrc);
         Button1->Enabled=true;
         CSpinEdit1->Value=0;
      }
   }
}
//---------------------------------------------------------------------------

void __fastcall TForm1::Button4Click(TObject *Sender)
{
   if(!bmpDst) return;
   SavePictureDialog1->InitialDir=ExtractFilePath(Application->ExeName);
   if(SavePictureDialog1->Execute())
   {
      bmpDst->SaveToFile(SavePictureDialog1->FileName);
   }
}
//---------------------------------------------------------------------------
void __fastcall TForm1::RotateBitmap(Graphics::TBitmap *bmpSrc, Graphics::TBitmap *bmpDst, int iAngle)
{
   double dSAngle, dCAngle;
   int iSrcCX, iSrcCY, iDstCX, iDstCY;
   int iSrcPX, iSrcPY, iDstPX, iDstPY;
   int iSrcW, iSrcH, iDstW, iDstH;
   int iTmpAngle;
   double dTmpHSIN, dTmpWSIN;
   double dPP, dPPAngle;
   int iX, iY;

   CGauge1->Progress=0;
   Application->ProcessMessages();
   iSrcW=bmpSrc->Width;
   iSrcH=bmpSrc->Height;

   switch(iAngle)
   {
      case 0:
         iDstW=iSrcW;
         iDstH=iDstH;
         bmpDst->Width=iDstW;
         bmpDst->Height=iDstH;
         for(iY=0; iY<iDstH; iY++)
         {
            for(iX=0; iX<iDstW; iX++)
            {
               iSrcPX=iX;
               iSrcPY=iY;
               bmpDst->Canvas->Pixels[iX][iY]=bmpSrc->Canvas->Pixels[iSrcPX][iSrcPY];
               CGauge1->Progress=(long)((double)((iY+1)*iDstW+(iX+1))/((double)iDstH*(double)iDstW)*(double)100);
               Application->ProcessMessages();
            }
         }
         break;
      case 90:
         iDstW=iSrcH;
         iDstH=iSrcW;
         bmpDst->Width=iDstW;
         bmpDst->Height=iDstH;
         for(iY=0; iY<iDstH; iY++)
         {
            for(iX=0; iX<iDstW; iX++)
            {
               iSrcPX=iY;
               iSrcPY=iDstW-1-iX;
               bmpDst->Canvas->Pixels[iX][iY]=bmpSrc->Canvas->Pixels[iSrcPX][iSrcPY];
               CGauge1->Progress=(long)((double)((iY+1)*iDstW+(iX+1))/((double)iDstH*(double)iDstW)*(double)100);
               Application->ProcessMessages();
            }
         }
         break;
      case 180:
         iDstW=iSrcW;
         iDstH=iSrcH;
         bmpDst->Width=iDstW;
         bmpDst->Height=iDstH;
         for(iY=0; iY<iDstH; iY++)
         {
            for(iX=0; iX<iDstW; iX++)
            {
               iSrcPX=iDstW-1-iX;
               iSrcPY=iDstH-1-iY;
               bmpDst->Canvas->Pixels[iX][iY]=bmpSrc->Canvas->Pixels[iSrcPX][iSrcPY];
               CGauge1->Progress=(long)((double)((iY+1)*iDstW+(iX+1))/((double)iDstH*(double)iDstW)*(double)100);
               Application->ProcessMessages();
            }
         }
         break;
      case 270:
         iDstW=iSrcH;
         iDstH=iSrcW;
         bmpDst->Width=iDstW;
         bmpDst->Height=iDstH;
         for(iY=0; iY<iDstH; iY++)
         {
            for(iX=0; iX<iDstW; iX++)
            {
               iSrcPX=iDstH-1-iY;
               iSrcPY=iX;
               bmpDst->Canvas->Pixels[iX][iY]=bmpSrc->Canvas->Pixels[iSrcPX][iSrcPY];
               CGauge1->Progress=(long)((double)((iY+1)*iDstW+(iX+1))/((double)iDstH*(double)iDstW)*(double)100);
               Application->ProcessMessages();
            }
         }
         break;
      default:
         dSAngle=sin((double)iAngle*((double)PI/(double)180.0));
         dCAngle=cos((double)iAngle*((double)PI/(double)180.0));
         if((iAngle>0 && iAngle<90) || (iAngle>180 && iAngle<270))
         {
            iTmpAngle=(iAngle>180)? iAngle-180: iAngle;
            dPP=sqrt(pow(iSrcW, 2)+pow(iSrcH, 2));
            dPPAngle=atan((double)iSrcH/(double)iSrcW)/((double)PI/(double)180.0);
            dTmpHSIN=sin((double)((90-iTmpAngle)+dPPAngle)*((double)PI/(double)180.0));
            dTmpWSIN=sin((double)(iTmpAngle+dPPAngle)*((double)PI/(double)180.0));
            iDstW=RoundTo(dTmpHSIN*dPP, 0);
            iDstH=RoundTo(dTmpWSIN*dPP, 0);
         }
         else
         {
            iTmpAngle=(iAngle>270)? iAngle-180: iAngle;
            dPP=sqrt(pow(iSrcW, 2)+pow(iSrcH, 2));
            dPPAngle=atan((double)iSrcH/(double)iSrcW)/(PI/180.0);
            dTmpHSIN=sin(((iTmpAngle-90)+dPPAngle)*(PI/180.0));
            dTmpWSIN=sin(((180-iTmpAngle)+dPPAngle)*(PI/180.0));
            iDstW=RoundTo(dTmpHSIN*dPP, 0);
            iDstH=RoundTo(dTmpWSIN*dPP, 0);
         }
         iSrcCX=iSrcW/2;
         iSrcCY=iSrcH/2;
         iDstCX=iDstW/2;
         iDstCY=iDstH/2;
         bmpDst->Width=iDstW;
         bmpDst->Height=iDstH;
         for(iY=0; iY<iDstH; iY++)
         {
            for(iX=0; iX<iDstW; iX++)
            {
               iDstPX=iX-iDstCX;
               iDstPY=iY-iDstCY;
               iSrcPX=RoundTo((dCAngle*iDstPX)+(dSAngle*iDstPY)+iSrcCX, 0);
               iSrcPY=RoundTo(-(dSAngle*iDstPX)+(dCAngle*iDstPY)+iSrcCY, 0);
               if(iSrcPX>=0 && iSrcPX<iSrcW && iSrcPY>=0 && iSrcPY<iSrcH)
               {
                  bmpDst->Canvas->Pixels[iX][iY]=bmpSrc->Canvas->Pixels[iSrcPX][iSrcPY];
               }
               CGauge1->Progress=(long)((double)((iY+1)*iDstW+(iX+1))/((double)iDstH*(double)iDstW)*(double)100);
               Application->ProcessMessages();
            }
         }
         break;
   }
}
//---------------------------------------------------------------------------

